c8d2ccc94b8e4105e7937e9886a5e23b7dd41473
[samba.git] / source4 / selftest / env / Samba4.pm
1 #!/usr/bin/perl
2 # Bootstrap Samba and run a number of tests against it.
3 # Copyright (C) 2005-2007 Jelmer Vernooij <jelmer@samba.org>
4 # Published under the GNU GPL, v3 or later.
5
6 package Samba4;
7
8 use strict;
9 use Cwd qw(abs_path);
10 use FindBin qw($RealBin);
11 use POSIX;
12
13 sub new($$$$) {
14         my ($classname, $bindir, $ldap, $setupdir) = @_;
15         my $self = { 
16                 vars => {}, 
17                 ldap => $ldap, 
18                 bindir => $bindir, 
19                 setupdir => $setupdir 
20         };
21         bless $self;
22         return $self;
23 }
24
25 sub openldap_start($$$) {
26         my ($slapd_conf, $uri, $logs) = @_;
27         my $oldpath = $ENV{PATH};
28         $ENV{PATH} = "/usr/local/sbin:/usr/sbin:/sbin:$ENV{PATH}";
29         system("slapd -d0 -f $slapd_conf -h $uri > $logs 2>&1 &");
30         $ENV{PATH} = $oldpath;
31 }
32
33 sub slapd_start($$)
34 {
35         my $count = 0;
36         my ($self, $env_vars) = @_;
37
38         my $uri = $env_vars->{LDAP_URI};
39
40         # running slapd in the background means it stays in the same process group, so it can be
41         # killed by timelimit
42         if ($self->{ldap} eq "fedora-ds") {
43                 system("$ENV{FEDORA_DS_PREFIX}/sbin/ns-slapd -D $env_vars->{FEDORA_DS_DIR} -d0 -i $env_vars->{FEDORA_DS_PIDFILE}> $env_vars->{LDAPDIR}/logs 2>&1 &");
44         } elsif ($self->{ldap} eq "openldap") {
45                 openldap_start($env_vars->{SLAPD_CONF}, $uri, "$env_vars->{LDAPDIR}/logs");
46         }
47         while (system("$self->{bindir}/ldbsearch -H $uri -s base -b \"\" supportedLDAPVersion > /dev/null") != 0) {
48                 $count++;
49                 if ($count > 40) {
50                     $self->slapd_stop($env_vars);
51                     return 0;
52                 }
53                 sleep(1);
54         }
55         return 1;
56 }
57
58 sub slapd_stop($$)
59 {
60         my ($self, $envvars) = @_;
61         if ($self->{ldap} eq "fedora-ds") {
62                 system("$envvars->{LDAPDIR}/slapd-samba4/stop-slapd");
63         } elsif ($self->{ldap} eq "openldap") {
64                 open(IN, "<$envvars->{OPENLDAP_PIDFILE}") or 
65                         die("unable to open slapd pid file: $envvars->{OPENLDAP_PIDFILE}");
66                 kill 9, <IN>;
67                 close(IN);
68         }
69         return 1;
70 }
71
72 sub check_or_start($$$) 
73 {
74         my ($self, $env_vars, $max_time) = @_;
75         return 0 if ( -p $env_vars->{SMBD_TEST_FIFO});
76
77         unlink($env_vars->{SMBD_TEST_FIFO});
78         POSIX::mkfifo($env_vars->{SMBD_TEST_FIFO}, 0700);
79         unlink($env_vars->{SMBD_TEST_LOG});
80         
81         print "STARTING SMBD... ";
82         my $pid = fork();
83         if ($pid == 0) {
84                 open STDIN, $env_vars->{SMBD_TEST_FIFO};
85                 open STDOUT, ">$env_vars->{SMBD_TEST_LOG}";
86                 open STDERR, '>&STDOUT';
87                 
88                 SocketWrapper::set_default_iface($env_vars->{SOCKET_WRAPPER_DEFAULT_IFACE});
89
90                 my $valgrind = "";
91                 if (defined($ENV{SMBD_VALGRIND})) {
92                     $valgrind = $ENV{SMBD_VALGRIND};
93                 } 
94
95                 $ENV{KRB5_CONFIG} = $env_vars->{KRB5_CONFIG}; 
96
97                 # Start slapd before smbd, but with the fifo on stdin
98                 if (defined($self->{ldap})) {
99                     $self->slapd_start($env_vars) or 
100                         die("couldn't start slapd (2nd time)");
101                 }
102
103                 my $optarg = "";
104                 if (defined($max_time)) {
105                         $optarg = "--maximum-runtime=$max_time ";
106                 }
107                 my $ret = system("$valgrind $self->{bindir}/smbd $optarg $env_vars->{CONFIGURATION} -M single -i --leak-report-full");
108                 if ($? == -1) {
109                         print "Unable to start smbd: $ret: $!\n";
110                         exit 1;
111                 }
112                 unlink($env_vars->{SMBD_TEST_FIFO});
113                 my $exit = $? >> 8;
114                 if ( $ret == 0 ) {
115                         print "smbd exits with status $exit\n";
116                 } elsif ( $ret & 127 ) {
117                         print "smbd got signal ".($ret & 127)." and exits with $exit!\n";
118                 } else {
119                         $ret = $? >> 8;
120                         print "smbd failed with status $exit!\n";
121                 }
122                 exit $exit;
123         }
124         print "DONE\n";
125
126         open(DATA, ">$env_vars->{SMBD_TEST_FIFO}");
127
128         return $pid;
129 }
130
131 sub wait_for_start($$)
132 {
133         my ($self, $testenv_vars) = @_;
134         # give time for nbt server to register its names
135         print "delaying for nbt name registration\n";
136         sleep 2;
137
138         # This will return quickly when things are up, but be slow if we 
139         # need to wait for (eg) SSL init 
140         system("bin/nmblookup $testenv_vars->{CONFIGURATION} $testenv_vars->{SERVER}");
141         system("bin/nmblookup $testenv_vars->{CONFIGURATION} -U $testenv_vars->{SERVER_IP} $testenv_vars->{SERVER}");
142         system("bin/nmblookup $testenv_vars->{CONFIGURATION} $testenv_vars->{NETBIOSNAME}");
143         system("bin/nmblookup $testenv_vars->{CONFIGURATION} -U $testenv_vars->{SERVER_IP} $testenv_vars->{NETBIOSNAME}");
144         system("bin/nmblookup $testenv_vars->{CONFIGURATION} $testenv_vars->{NETBIOSALIAS}");
145         system("bin/nmblookup $testenv_vars->{CONFIGURATION} -U $testenv_vars->{SERVER_IP} $testenv_vars->{NETBIOSALIAS}");
146         system("bin/nmblookup $testenv_vars->{CONFIGURATION} $testenv_vars->{SERVER}");
147         system("bin/nmblookup $testenv_vars->{CONFIGURATION} -U $testenv_vars->{SERVER_IP} $testenv_vars->{SERVER}");
148         system("bin/nmblookup $testenv_vars->{CONFIGURATION} $testenv_vars->{NETBIOSNAME}");
149         system("bin/nmblookup $testenv_vars->{CONFIGURATION} -U $testenv_vars->{SERVER_IP} $testenv_vars->{NETBIOSNAME}");
150         system("bin/nmblookup $testenv_vars->{CONFIGURATION} $testenv_vars->{NETBIOSALIAS}");
151         system("bin/nmblookup $testenv_vars->{CONFIGURATION} -U $testenv_vars->{SERVER_IP} $testenv_vars->{NETBIOSALIAS}");
152
153         print $self->getlog_env($testenv_vars);
154 }
155
156 sub write_ldb_file($$$)
157 {
158         my ($self, $file, $ldif) = @_;
159
160         open(LDIF, "|$self->{bindir}/ldbadd -H $file >/dev/null");
161         print LDIF $ldif;
162         return close(LDIF);
163 }
164
165 sub add_wins_config($$)
166 {
167         my ($self, $privatedir) = @_;
168
169         return $self->write_ldb_file("$privatedir/wins_config.ldb", "
170 dn: name=TORTURE_6,CN=PARTNERS
171 objectClass: wreplPartner
172 name: TORTURE_6
173 address: 127.0.0.6
174 pullInterval: 0
175 pushChangeCount: 0
176 type: 0x3
177 ");
178 }
179
180 sub mk_fedora_ds($$$)
181 {
182         my ($self, $ldapdir, $configuration) = @_;
183
184         my $fedora_ds_inf = "$ldapdir/fedorads.inf";
185         my $fedora_ds_extra_ldif = "$ldapdir/fedorads-partitions.ldif";
186
187         #Make the subdirectory be as fedora DS would expect
188         my $fedora_ds_dir = "$ldapdir/slapd-samba4";
189
190         my $pidfile = "$fedora_ds_dir/logs/slapd-samba4.pid";
191
192 my $dir = getcwd();
193 chdir "$ENV{FEDORA_DS_PREFIX}/bin" || die;
194         if (system("perl $ENV{FEDORA_DS_PREFIX}/bin/ds_newinst.pl $fedora_ds_inf >&2") != 0) {
195             chdir $dir;
196             die("perl $ENV{FEDORA_DS_PREFIX}/bin/ds_newinst.pl $fedora_ds_inf FAILED: $?");
197         }
198         chdir $dir || die;
199
200         system("cat $fedora_ds_extra_ldif >> $fedora_ds_dir/dse.ldif");
201
202         system("$self->{bindir}/ad2oLschema $configuration -H $ldapdir/schema-tmp.ldb --option=convert:target=fedora-ds -I $self->{setupdir}/schema-map-fedora-ds-1.0 -O $fedora_ds_dir/schema/99_ad.ldif >&2") == 0 or die("schema conversion for Fedora DS failed");
203
204         return ($fedora_ds_dir, $pidfile);
205 }
206
207 sub mk_openldap($$$)
208 {
209         my ($self, $ldapdir, $configuration) = @_;
210
211         my $slapd_conf = "$ldapdir/slapd.conf";
212         my $pidfile = "$ldapdir/slapd.pid";
213         my $modconf = "$ldapdir/modules.conf";
214
215         #This uses the backend provision we just did, to read out the schema
216         system("$self->{bindir}/ad2oLschema $configuration --option=convert:target=openldap -H $ldapdir/schema-tmp.ldb -I $self->{setupdir}/schema-map-openldap-2.3 -O $ldapdir/backend-schema.schema >&2") == 0 or die("schema conversion for OpenLDAP failed");
217
218         my $oldpath = $ENV{PATH};
219         $ENV{PATH} = "/usr/local/sbin:/usr/sbin:/sbin:$ENV{PATH}";
220
221         unlink($modconf);
222         open(CONF, ">$modconf"); close(CONF);
223
224         if (system("slaptest -u -f $slapd_conf >&2") != 0) {
225                 open(CONF, ">$modconf"); 
226                 # enable slapd modules
227                 print CONF "
228 modulepath      /usr/lib/ldap
229 moduleload      back_bdb
230 moduleload      syncprov
231 ";
232                 close(CONF);
233         }
234
235         if (system("slaptest -u -f $slapd_conf >&2") != 0) {
236                 open(CONF, ">$modconf"); 
237                 # enable slapd modules (Fedora layout)
238                 print CONF "
239 modulepath      /usr/lib/openldap
240 moduleload      syncprov
241 ";
242                 close(CONF);
243         }
244
245         if (system("slaptest -u -f $slapd_conf >&2") != 0) {
246                 open(CONF, ">$modconf"); 
247                 # enable slapd modules (Fedora x86_64 layout)
248                 print CONF "
249 modulepath      /usr/lib64/openldap
250 moduleload      syncprov
251 ";
252                 close(CONF);
253         }
254
255         system("slaptest -u -f $slapd_conf") == 0 or die("slaptest still fails after adding modules");
256
257     
258         $ENV{PATH} = $oldpath;
259
260         return ($slapd_conf, $pidfile);
261 }
262
263 sub provision($$$$$$)
264 {
265         my ($self, $prefix, $server_role, $netbiosname, $netbiosalias, $swiface, $password) = @_;
266
267         my $smbd_loglevel = 1;
268         my $username = "administrator";
269         my $domain = "SAMBADOMAIN";
270         my $realm = "SAMBA.EXAMPLE.COM";
271         my $dnsname = "samba.example.com";
272         my $basedn = "dc=samba,dc=example,dc=com";
273         my $root = ($ENV{USER} or $ENV{LOGNAME} or `whoami`);
274         my $srcdir="$RealBin/..";
275         -d $prefix or mkdir($prefix, 0777) or die("Unable to create $prefix");
276         my $prefix_abs = abs_path($prefix);
277         my $tmpdir = "$prefix_abs/tmp";
278         my $etcdir = "$prefix_abs/etc";
279         my $piddir = "$prefix_abs/pid";
280         my $conffile = "$etcdir/smb.conf";
281         my $krb5_config = "$etcdir/krb5.conf";
282         my $privatedir = "$prefix_abs/private";
283         my $ncalrpcdir = "$prefix_abs/ncalrpc";
284         my $lockdir = "$prefix_abs/lockdir";
285         my $winbindd_socket_dir = "$prefix_abs/winbind_socket";
286
287         my $configuration = "--configfile=$conffile";
288         my $ldapdir = "$privatedir/ldap";
289
290         my $tlsdir = "$privatedir/tls";
291
292         my $ifaceipv4 = "127.0.0.$swiface";
293         my $interfaces = "$ifaceipv4/8";
294
295         (system("rm -rf $prefix/*") == 0) or die("Unable to clean up");
296         mkdir($_, 0777) foreach ($privatedir, $etcdir, $piddir, $ncalrpcdir, $lockdir, 
297                 $tmpdir);
298
299
300         my $localdomain = $domain;
301         $localdomain = $netbiosname if $server_role eq "member server";
302         my $localrealm = $realm;
303         $localrealm = $netbiosname if $server_role eq "member server";
304         my $localbasedn = $basedn;
305         $localbasedn = "DC=$netbiosname" if $server_role eq "member server";
306
307         open(CONFFILE, ">$conffile");
308         print CONFFILE "
309 [global]
310         netbios name = $netbiosname
311         netbios aliases = $netbiosalias
312         workgroup = $domain
313         realm = $realm
314         private dir = $privatedir
315         pid directory = $piddir
316         ncalrpc dir = $ncalrpcdir
317         lock dir = $lockdir
318         setup directory = $self->{setupdir}
319         js include = $srcdir/scripting/libjs
320         winbindd socket directory = $winbindd_socket_dir
321         winbind separator = /
322         name resolve order = bcast
323         interfaces = $interfaces
324         tls dh params file = $tlsdir/dhparms.pem
325         panic action = $srcdir/script/gdb_backtrace \%PID% \%PROG%
326         wins support = yes
327         server role = $server_role
328         max xmit = 32K
329         server max protocol = SMB2
330         notify:inotify = false
331         ldb:nosync = true
332         system:anonymous = true
333 #We don't want to pass our self-tests if the PAC code is wrong
334         gensec:require_pac = true
335         log level = $smbd_loglevel
336
337 [tmp]
338         path = $tmpdir
339         read only = no
340         ntvfs handler = posix
341         posix:sharedelay = 100000
342         posix:eadb = $lockdir/eadb.tdb
343
344 [cifs]
345         read only = no
346         ntvfs handler = cifs
347         cifs:server = $netbiosname
348         cifs:share = tmp
349 #There is no username specified here, instead the client is expected
350 #to log in with kerberos, and smbd will used delegated credentials.
351
352 [simple]
353         path = $tmpdir
354         read only = no
355         ntvfs handler = simple
356
357 [cifsposix]
358         copy = simple
359         ntvfs handler = cifsposix   
360 ";
361         close(CONFFILE);
362
363         die ("Unable to create key blobs") if
364                 (system("TLSDIR=$tlsdir $RealBin/mk-keyblobs.sh") != 0);
365
366         open(KRB5CONF, ">$krb5_config");
367         print KRB5CONF "
368 #Generated krb5.conf for $realm
369
370 [libdefaults]
371  default_realm = $realm
372  dns_lookup_realm = false
373  dns_lookup_kdc = false
374  ticket_lifetime = 24h
375  forwardable = yes
376
377 [realms]
378  $realm = {
379   kdc = 127.0.0.1:88
380   admin_server = 127.0.0.1:88
381   default_domain = $dnsname
382  }
383  $dnsname = {
384   kdc = 127.0.0.1:88
385   admin_server = 127.0.0.1:88
386   default_domain = $dnsname
387  }
388  $domain = {
389   kdc = 127.0.0.1:88
390   admin_server = 127.0.0.1:88
391   default_domain = $dnsname
392  }
393
394 [appdefaults]
395         pkinit_anchors = FILE:$tlsdir/ca.pem
396
397 [kdc]
398         enable-pkinit = true
399         pkinit_identity = FILE:$tlsdir/kdc.pem,$tlsdir/key.pem
400         pkinit_anchors = FILE:$tlsdir/ca.pem
401
402 [domain_realm]
403  .$dnsname = $realm
404 ";
405         close(KRB5CONF);
406
407 #Ensure the config file is valid before we start
408         if (system("$self->{bindir}/testparm $configuration -v --suppress-prompt >/dev/null 2>&1") != 0) {
409                 system("$self->{bindir}/testparm -v --suppress-prompt $configuration >&2");
410                 die("Failed to create a valid smb.conf configuration!");
411         }
412
413         (system("($self->{bindir}/testparm $configuration -v --suppress-prompt --parameter-name=\"netbios name\" --section-name=global 2> /dev/null | grep -i \"^$netbiosname\" ) >/dev/null 2>&1") == 0) or die("Failed to create a valid smb.conf configuration!");
414
415 my @provision_options = ("$self->{bindir}/smbscript", "$self->{setupdir}/provision");
416         push (@provision_options, split(' ', $configuration));
417         push (@provision_options, "--host-name=$netbiosname");
418         push (@provision_options, "--host-ip=$ifaceipv4");
419         push (@provision_options, "--quiet");
420         push (@provision_options, "--domain=$localdomain");
421         push (@provision_options, "--realm=$localrealm");
422         push (@provision_options, "--adminpass=$password");
423         push (@provision_options, "--krbtgtpass=krbtgt$password");
424         push (@provision_options, "--machinepass=machine$password");
425         push (@provision_options, "--root=$root");
426         push (@provision_options, "--simple-bind-dn=cn=Manager,$localbasedn");
427         push (@provision_options, "--password=$password");
428         push (@provision_options, "--root=$root");
429
430         my $ldap_uri= "$ldapdir/ldapi";
431         $ldap_uri =~ s|/|%2F|g;
432         $ldap_uri = "ldapi://$ldap_uri";
433
434         my $ret = {
435                 KRB5_CONFIG => $krb5_config,
436                 PIDDIR => $piddir,
437                 SERVER => $netbiosname,
438                 SERVER_IP => $ifaceipv4,
439                 NETBIOSNAME => $netbiosname,
440                 NETBIOSALIAS => $netbiosalias,
441                 LDAP_URI => $ldap_uri,
442                 DOMAIN => $domain,
443                 USERNAME => $username,
444                 REALM => $realm,
445                 PASSWORD => $password,
446                 LDAPDIR => $ldapdir,
447                 WINBINDD_SOCKET_DIR => $winbindd_socket_dir,
448                 NCALRPCDIR => $ncalrpcdir,
449                 LOCKDIR => $lockdir,
450                 CONFIGURATION => $configuration,
451                 SOCKET_WRAPPER_DEFAULT_IFACE => $swiface
452         };
453
454         if (defined($self->{ldap})) {
455
456                 push (@provision_options, "--ldap-backend=$ldap_uri");
457                 system("$self->{bindir}/smbscript $self->{setupdir}/provision-backend $configuration --ldap-manager-pass=$password --root=$root --realm=$localrealm --host-name=$netbiosname --ldap-backend-type=$self->{ldap}>&2") == 0 or die("backend provision failed");
458
459                 if ($self->{ldap} eq "openldap") {
460                        ($ret->{SLAPD_CONF}, $ret->{OPENLDAP_PIDFILE}) = $self->mk_openldap($ldapdir, $configuration) or die("Unable to create openldap directories");
461                 } elsif ($self->{ldap} eq "fedora-ds") {
462                        ($ret->{FEDORA_DS_DIR}, $ret->{FEDORA_DS_PIDFILE}) = $self->mk_fedora_ds($ldapdir, $configuration) or die("Unable to create fedora ds directories");
463                        push (@provision_options, "--ldap-module=nsuniqueid");
464                        push (@provision_options, "--aci=aci:: KHRhcmdldGF0dHIgPSAiKiIpICh2ZXJzaW9uIDMuMDthY2wgImZ1bGwgYWNjZXNzIHRvIGFsbCBieSBhbGwiO2FsbG93IChhbGwpKHVzZXJkbiA9ICJsZGFwOi8vL2FueW9uZSIpOykK");
465                  }
466
467                 $self->slapd_start($ret) or 
468                         die("couldn't start slapd");
469         }
470
471         (system(@provision_options) == 0) or die("Unable to provision");
472
473         if (defined($self->{ldap})) {
474                 $self->slapd_stop($ret) or 
475                         die("couldn't stop slapd");
476         }
477
478         return $ret; 
479 }
480
481 sub provision_member($$$)
482 {
483         my ($self, $prefix, $dcvars) = @_;
484         print "PROVISIONING MEMBER...";
485
486         my $ret = $self->provision($prefix,
487                                    "member server",
488                                    "localmember3",
489                                    "localmember",
490                                    3,
491                                    "localmemberpass");
492
493         $ret or die("Unable to provision");
494
495         my $cmd = "";
496         $cmd .= "SOCKET_WRAPPER_DEFAULT_IFACE=\"$ret->{SOCKET_WRAPPER_DEFAULT_IFACE}\" ";
497         $cmd .= "KRB5_CONFIG=\"$ret->{KRB5_CONFIG}\" ";
498         $cmd .= "$self->{bindir}/net join $ret->{CONFIGURATION} $dcvars->{DOMAIN} member";
499         $cmd .= " -U$dcvars->{USERNAME}\%$dcvars->{PASSWORD}";
500
501         system($cmd) == 0 or die("Join failed\n$cmd");
502
503         $ret->{SMBD_TEST_FIFO} = "$prefix/smbd_test.fifo";
504         $ret->{SMBD_TEST_LOG} = "$prefix/smbd_test.log";
505         $ret->{SMBD_TEST_LOG_POS} = 0;
506
507         $ret->{DC_SERVER} = $dcvars->{SERVER};
508         $ret->{DC_SERVER_IP} = $dcvars->{SERVER_IP};
509         $ret->{DC_NETBIOSNAME} = $dcvars->{NETBIOSNAME};
510         $ret->{DC_NETBIOSALIAS} = $dcvars->{NETBIOSALIAS};
511         $ret->{DC_USERNAME} = $dcvars->{USERNAME};
512         $ret->{DC_PASSWORD} = $dcvars->{PASSWORD};
513
514         return $ret;
515 }
516
517 sub provision_dc($$)
518 {
519         my ($self, $prefix) = @_;
520
521         print "PROVISIONING DC...";
522         my $ret = $self->provision($prefix,
523                                    "domain controller",
524                                    "localdc1",
525                                    "localdc",
526                                    1,
527                                    "localdcpass");
528
529         $self->add_wins_config("$prefix/private") or 
530                 die("Unable to add wins configuration");
531
532         $ret->{SMBD_TEST_FIFO} = "$prefix/smbd_test.fifo";
533         $ret->{SMBD_TEST_LOG} = "$prefix/smbd_test.log";
534         $ret->{SMBD_TEST_LOG_POS} = 0;
535         return $ret;
536 }
537
538 sub teardown_env($$)
539 {
540         my ($self, $envvars) = @_;
541         my $pid;
542
543         close(DATA);
544
545         if (-f "$envvars->{PIDDIR}/smbd.pid" ) {
546                 open(IN, "<$envvars->{PIDDIR}/smbd.pid") or die("unable to open smbd pid file");
547                 $pid = <IN>;
548                 close(IN);
549
550                 # Give the process 20 seconds to exit.  gcov needs
551                 # this time to write out the covarge data
552                 my $count = 0;
553                 until (kill(0, $pid) == 0) {
554                     # if no process sucessfully signalled, then we are done
555                     sleep(1);
556                     $count++;
557                     last if $count > 20;
558                 }
559                 
560                 # If it is still around, kill it
561                 if ($count > 20) {
562                     print "smbd process $pid took more than $count seconds to exit, killing\n";
563                     kill 9, $pid;
564                 }
565         }
566
567         my $failed = $? >> 8;
568
569         $self->slapd_stop($envvars) if ($self->{ldap});
570
571         print $self->getlog_env($envvars);
572
573         return $failed;
574 }
575
576 sub getlog_env($$)
577 {
578         my ($self, $envvars) = @_;
579         my $title = "SMBD LOG of: $envvars->{NETBIOSNAME}\n";
580         my $out = $title;
581
582         open(LOG, "<$envvars->{SMBD_TEST_LOG}");
583
584         seek(LOG, $envvars->{SMBD_TEST_LOG_POS}, SEEK_SET);
585         while (<LOG>) {
586                 $out .= $_;
587         }
588         $envvars->{SMBD_TEST_LOG_POS} = tell(LOG);
589         close(LOG);
590
591         return "" if $out eq $title;
592  
593         return $out;
594 }
595
596 sub check_env($$)
597 {
598         my ($self, $envvars) = @_;
599
600         return 1 if (-p $envvars->{SMBD_TEST_FIFO});
601
602         print $self->getlog_env($envvars);
603
604         return 0;
605 }
606
607 sub setup_env($$$)
608 {
609         my ($self, $envname, $path) = @_;
610
611         if ($envname eq "dc") {
612                 return $self->setup_dc("$path/dc");
613         } elsif ($envname eq "member") {
614                 if (not defined($self->{vars}->{dc})) {
615                         $self->setup_dc("$path/dc");
616                 }
617                 return $self->setup_member("$path/member", $self->{vars}->{dc});
618         } else {
619                 die("Samba4 can't provide environment '$envname'");
620         }
621 }
622
623 sub setup_member($$$$)
624 {
625         my ($self, $path, $dc_vars) = @_;
626
627         my $env = $self->provision_member($path, $dc_vars);
628
629         $self->check_or_start($env, ($ENV{SMBD_MAXTIME} or 7500));
630
631         $self->wait_for_start($env);
632
633         return $env;
634 }
635
636 sub setup_dc($$)
637 {
638         my ($self, $path) = @_;
639
640         my $env = $self->provision_dc($path);
641
642         $self->check_or_start($env, 
643                 ($ENV{SMBD_MAXTIME} or 7500));
644
645         $self->wait_for_start($env);
646
647         $self->{vars}->{dc} = $env;
648
649         return $env;
650 }
651
652 sub stop($)
653 {
654         my ($self) = @_;
655 }
656
657 1;